/*
****************************************
**     http://linux.firststeps.ru     **
**            23.02.2002              **
**          dron@mjk.msk.ru           **
****************************************
*/

#include <stdio.h>

#include <dlfcn.h>      


int main(int argc, char* argv[]){

	void *ext_library;
	double value=0;
	double (*powerfunc)(double x);

	ext_library = dlopen("/1l/g/test/libpowers.so",RTLD_LAZY);
	if (!ext_library){
		fprintf(stderr,"dlopen() error: %s\n", dlerror());
		return 1;
	};

	powerfunc = dlsym(ext_library, argv[1]);	
	value=3.0;

	printf("%s(%f) = %f\n",argv[1],value,(*powerfunc)(value));

	dlclose(ext_library);
};